package com.insanityengine.ghia.apps;

import java.applet.*;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;

import java.util.*;

import com.insanityengine.ghia.m3.*;
import com.insanityengine.ghia.util.*;
import com.insanityengine.ghia.model.*;
import com.insanityengine.ghia.pixels.*;
import com.insanityengine.ghia.libograf.*;

/**
 * 
 * <P>
 * Loads aoff geometry files and stuff
 * </P>
 *
 * <table border="1">
 * <topic>945*5 = 4725 triangles</topic>
 * <TH>RendererName</TH>
 * <TH>KiloTrianglesPerSecond</TH>
 * <TH>SnapShot</TH>
 * <TR valign="top">
 *	<TD>Memagery</TD>
 *  <TD>1102/61.640=17.878002 * 4725 =  84475 tps =  84 kts</TD>
 *	<TD><img src="http://ghia.insanityengine.com/images/old_snaps/Memagery_Geom.gif"/></TD>
 * </TR>
 * <TR valign="top">
 *	<TD>WireFuRenderer</TD>
 *	<TD>2370/60.817=38.969368 * 4725 = 184130 tps = 184 kts</TD>
 *	<TD><img src="http://ghia.insanityengine.com/images/old_snaps/WireFuRender_Geom.gif"/></TD>
 * </TR>
 * <TR valign="top">
 *	<TD>ZortPolyRenderer</TD>
 *	<TD>97510/60.306=1616.9204 * 4725 = 7639948 tps = 76 kts</TD>
 *	<TD><img src="http://ghia.insanityengine.com/images/old_snaps/ZortPolyRenderer_Geom.gif"/></TD>
 * </TR>
 * </table>
 *
 * @author BrianHammond
 *
 */
public class GeomLoadem extends AppletBase {
	
	/////////////////////////////////////////////////////////////

	/** 
	 * 
	 * main
	 * 
	 * @param argv
	 * 
	 */
	public final static void main( String argv[] ) {
		GeomLoadem gloadem = new GeomLoadem();
		gloadem.frame();

		float f;
		for ( int i = 0 ; i < argv.length ; i++ ) {
			if ( '-' != argv[ i ].charAt( 0 ) ) {
				gloadem.load( argv[ i ] );
			} else {
				switch( argv[ i++ ] .charAt( 1 ) ) {
					case 's': 
						gloadem.setScale( ( float ) Stdlib.atof( argv[ i ] ) );
						break;
					case 't':
						gloadem.setSkin( argv[ i ] );
						break;
				}
			}
		}
	}

	/////////////////////////////////////////////////////////////
	
	/** 
	 * 
	 * load
	 * 
	 * @param geom
	 * 
	 */
	public void load( String geom ) {
		loader = new GeomLoader( geom );
		loader.center();
		System.out.println( "-----------------------------------" );
		System.out.println( geom + " : " + loader );
		System.out.println( "-----------------------------------" );
	}

	/** 
	 * 
	 * setSkin
	 * 
	 * @param href
	 * 
	 */
	public void setSkin( String href ) {
		skin = Imago.skinImage( href );
		gl.getRenderer().setSkin( skin );
	}

	/** 
	 * 
	 * initImpl
	 * 
	 * @param w
	 * @param h
	 * 
	 */
	public void initImpl( int w, int h ) {

		try {
			String geom = getCodeBase() + getParameter( "file" );
			load( geom );
		} catch ( Exception e ) {
		}
	
		try {
			float f = ( float ) Stdlib.atof( getParameter( "scale" ) );
			if ( 0 != f ) setScale( f );
		} catch ( Exception e ) {
			
		}

		try {
			skin = Imago.skinImage( getCodeBase() + "/" + getParameter( "skin" ) );
		} catch ( Exception e ) {
		}
		
		if ( null == skin ) {
			int[] sk = { 0x0000FF00 };
			skin = new ImageSkin( 1, 1, sk );
			gl.getRenderer().setSkin( skin );
		}
	}

	/** 
	 * 
	 * drawImpl
	 * 
	 */
	public void drawImpl() {

		gl.getRenderer().clear();

		gl.identity();
		gl.rotate( rotation );
		gl.scale( scale );
		
		if ( null == loader ) return;

		loader.draw( gl );

		if ( false ) cbgb();
	}

	/** 
	 * 
	 * cbgb
	 * 
	 */
	public void cbgb() {
		float f = 14;
		
		gl.identity();
		gl.rotate( rotation );
		gl.scale( scale.set( f ) );

		float x = rotation.getX();
		float y = rotation.getY();
		float z = rotation.getZ();

		cb( x, y, z, -f, 0, 0 );
		cb( x, y, z, +f, 0, 0 );
		cb( x, y, z, 0, -f, 0 );
		cb( x, y, z, 0, +f, 0 );
		cb( x, y, z, 0, 0, -f );
		cb( x, y, z, 0, 0, +f );
	}
	
	/** 
	 * 
	 * cb
	 * 
	 * @param x
	 * @param y
	 * @param z
	 * @param a
	 * @param b
	 * @param c
	 * 
	 */
	public void cb( float x, float y, float z, float a, float b, float c ) {
		gl.push(); 
		gl.translate( new Pt3( a, b, c ) );
			loader.draw( gl );
		gl.pop();
	}

	/** 
	 * 
	 * setScale
	 * 
	 * @param f
	 * 
	 */
	public void setScale( float f ) {
		if ( 0 != f ) {
			scale.set( f );
			System.out.println( "" + " scale = " + scale );
		}	
	}

	    
	/** 
	 * 
	 * printRates
	 * 
	 * @return a float
	 * 
	 */
	public float printRates() {
		float fps = super.printRates();
		System.out.println( "pps = " + fps * loader.getSurfaceCount() );
		return fps;
	}
			

 	// 
	
	private GeomLoader loader = null;
	private Pt3 scale = new Pt3( 10.0f );
};

/**
 *
 * $Log: GeomLoadem.java,v $
 * Revision 1.12  2005/03/26 23:42:41  brian
 * fix links
 *
 * Revision 1.11  2005/03/21 05:52:12  brian
 * add enuff stuff to be able to calc pps (polygons per second)
 *
 * Revision 1.10  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.9  2005/03/11 23:35:31  brian
 * major refactoring to add in com.insanityengine.ghia.libograf.State bitz
 *
 * Revision 1.8  2005/03/10 13:31:19  brian
 * introduce com.insanityengine.ghia/libograf/State to pave the way for quaternions based LiboGrafInterface implementation
 *
 * Revision 1.7  2004/09/11 14:37:21  brian
 * added RendererConsumer and stuff
 *
 * Revision 1.6  2004/09/02 13:17:16  brian
 * the big reorg
 *
 * Revision 1.5  2004/09/01 14:54:41  brian
 * add support for parameters and cli args...
 *
 * Revision 1.4  2004/09/01 01:52:47  brian
 * added test results (ok, and images) to javadoc
 *
 * Revision 1.3  2004/09/01 01:10:42  brian
 * fix class level javadoc placement
 *
 * Revision 1.2  2004/09/01 00:11:06  brian
 * author, log and header stuff
 *
 *
 */
