package com.insanityengine.ghia.apps;

import java.applet.*;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;

import java.util.*;

import com.insanityengine.ghia.m3.*;
import com.insanityengine.ghia.model.*;
import com.insanityengine.ghia.pixels.*;
import com.insanityengine.ghia.pixelops.*;
import com.insanityengine.ghia.libograf.*;

/**
 *
 * <P>
 * This is used primarily for looking foxy and benchmarking
 * </P>
 *
 * <table border="1">
 * <topic>945*5 = 4725 triangles</topic>
 * <TH>RendererName</TH>
 * <TH>KiloTrianglesPerSecond</TH>
 * <TH>SnapShot</TH>
 * <TR valign="top">
 *  <TD>Memagery</TD>
 *  <TD>51 fps</TD>
 *  <TD><img src="http://ghia.insanityengine.com/images/old_snaps/Memagery_Light.gif"/></TD>
 * </TR>
 * <TR valign="top">
 *  <TD>WireFuRenderer</TD>
 *  <TD>1593 fps</TD>
 *  <TD><img src="http://ghia.insanityengine.com/images/old_snaps/WireFuRender_Light.gif"/></TD>
 * </TR>
 * <TR valign="top">
 *  <TD>ZortPolyRenderer</TD>
 *  <TD>1646 fps</TD>
 *  <TD><img src="http://ghia.insanityengine.com/images/old_snaps/ZortPolyRenderer_Light.gif"/></TD>
 * </TR>
 * </table>
 *
 * @author BrianHammond
 *
 */

public class Light extends AppletBase {

	/////////////////////////////////////////////////////////////

	public final static void main( String argv[] ) {
		Light lite = new Light();
		lite.frame();
	}
	
	/////////////////////////////////////////////////////////////
	
	public Light() {
	}
	
	/////////////////////////////////////////////////////////////
	
	public void initImpl( int w, int h ) {
		if ( gl.getRenderer() instanceof PixelBufferReadInterface ) {
			skin = new ImageSkin( 
				( PixelBufferReadInterface ) gl.getRenderer() 
			);
		}
		
		fx = new BufferFx( gl.getRenderer() );
		gl.getRenderer().setShadingMethod( M3_Constants.DEPTH_SHADE );
		gl.getRenderer().setShadingMethod( M3_Constants.NONE_SHADE );
		gl.getRenderer().setShadingMethod( M3_Constants.NORM_SHADE );
	}

	public final void drawImpl() {
		float f;

		gl.getRenderer().clearDepthBuffer();
		gl.getRenderer().setSkin( skin );

		if ( false && BufferFx.objectSupportsFx( gl.getRenderer() ) ) {
			fx.or( 0x00D05030 );
			fx.smoothoDoomo();
			fx.and( 0xFFEE9977 );
		} else {
			gl.getRenderer().setClearColor( 0x0000FF00 );
			gl.getRenderer().clearColorBuffer();
		}

		gl.identity();
		gl.rotate( rotation );

		Cube.cube( gl );

		f = 0.2f;
		gl.identity();
		gl.rotate( rotation );
		gl.scale( scale.set( f ) );
		
		f = 14;
		Cube.cubeAt( gl, +f, 0, 0 );
		Cube.cubeAt( gl, 0, +f, 0 );
		Cube.cubeAt( gl, 0, 0, +f );
		
		Cube.cubeAt( gl, -f, 0, 0 );
		Cube.cubeAt( gl, 0, -f, 0 );
		Cube.cubeAt( gl, 0, 0, -f );
	}

	////

	private Pt3 scale = new Pt3();
};

/**
 *
 * $Log: Light.java,v $
 * Revision 1.23  2005/03/26 23:42:41  brian
 * fix links
 *
 * Revision 1.22  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.21  2005/03/11 23:35:31  brian
 * major refactoring to add in com.insanityengine.ghia.libograf.State bitz
 *
 * Revision 1.20  2005/02/17 03:31:13  brian
 * good stuff???
 *
 * Revision 1.19  2004/09/13 03:06:41  brian
 * fix up Frustrum.toScreen, still working on JoglRenderer's texture support... sigh...
 *
 * Revision 1.18  2004/09/11 14:37:21  brian
 * added RendererConsumer and stuff
 *
 * Revision 1.17  2004/09/08 02:26:40  brian
 * set normal shading as the default
 *
 * Revision 1.16  2004/09/02 23:32:26  brian
 * dont make the RendererInterface extend PixelBufferInterface
 *
 * Revision 1.15  2004/09/02 15:43:46  brian
 * redefine PixelBufferReadInterface so BufferFx can use it as an interface rather than the RenderInterface
 *
 * Revision 1.14  2004/09/02 13:17:16  brian
 * the big reorg
 *
 * Revision 1.13  2004/09/01 01:52:47  brian
 * added test results (ok, and images) to javadoc
 *
 * Revision 1.12  2004/09/01 01:10:42  brian
 * fix class level javadoc placement
 *
 * Revision 1.11  2004/09/01 00:11:06  brian
 * author, log and header stuff
 *
 *
 */
