package com.insanityengine.ghia.libograf;

import java.applet.*;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;

import java.util.*;

import com.insanityengine.ghia.m3.*;
import com.insanityengine.ghia.pixels.*;
import com.insanityengine.ghia.pixelops.*;

/**
 *
 * <P>
 * Takes care of most of the Applet cruft, implement initImpl 
 * and drawImpl and viola!
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/libograf/AppletBase.java,v 1.15 2005/03/29 02:38:33 brian Exp $
 *
 */
public class AppletBase
	extends 
		JApplet
	implements 
		  KeyListener
		, MouseListener
		, MouseMotionListener
		, ActionListener
		, Runnable
		, DrawingInterface
{
	
	/////////////////////////////////////////////////////////////
/*
	public final static void main( String argv[] ) {
		new AppletBase().frame();
	}	
*/
	/////////////////////////////////////////////////////////////

	// override these

	/** 
	 * 
	 * initImpl
	 * 
	 * @param w
	 * @param h
	 * 
	 */
	public void initImpl( int w, int h ) {
	}

	/** 
	 * 
	 * drawImpl
	 * 
	 */
	public void drawImpl() {
	}

	/////////////////////////////////////////////////////////////
	
	/** 
	 * 
	 * Constructor
	 * 
	 */
	public AppletBase() {
		performanceTest = ( null != System.getProperty( "m3_perfHarness" ) );
	}

	/** 
	 * 
	 * Constructor
	 * 
	 * @param w
	 * @param h
	 * 
	 */
	public AppletBase( int w, int h ) {
		this();
		init( w, h );
	}
	
	/////////////////////////////////////////////////////////////
	
	/** 
	 * 
	 * init
	 * 
	 */
	public void init() {
		init( getSize().width, getSize().height );
	}

	/** 
	 * 
	 * paint
	 * 
	 * @param g
	 * 
	 */
	public void paint( Graphics g ) { 
		update( g ); 
	}

	/** 
	 * 
	 * update
	 * 
	 * @param g
	 * 
	 */
	public void update( Graphics g ) {
		gl.render( g );
		fcount++;
	}

	/** 
	 * 
	 * start
	 * 
	 */
	public void start() {
		badJoke();

		if ( null != thread ) return; 
		thread = new Thread( this );
		thread.start();
	}
	
	/** 
	 * 
	 * stop
	 * 
	 */
	public void stop() {
		if ( null == thread ) return;
		//thread.stop();
	}
	
	/** 
	 * 
	 * run
	 * 
	 */
	public void run() {
		while ( keepRunning ) {
			drawFrame();

			if ( null != rname ) {
				gl.createRenderer( rname );
				rname = null;
			}
		}
	}

	/**
	 *
	 * Draw a frame
	 *
	 * @param gl to use
	 *
	 */
	public void draw( LiboGrafInterface gl ) {

		if ( whenPerf == fcount ) the5k();

		if ( null == gl ) {
			return;
		}
		//gl.getRenderer().clearDepthBuffer();
		
		drawImpl();

		// just for fun
		if ( !true ) {
			if ( gl.getRenderer() instanceof PixelBufferReadInterface ) {
				com.insanityengine.ghia.pixelops.TextDitherer.dither( 
					( PixelBufferReadInterface ) gl.getRenderer() 
				);
			} 
		}

		if ( paused ) return;

		rotation.add( 0.1f );
	}

	/** 
	 * 
	 * println
	 * 
	 * @param o
	 * 
	 */
	public void println( Object o ) {
		System.out.println( o );
	}

	/** 
	 * 
	 * frame
	 * 
	 */
	public void frame() {
		frame( 500, 350 );
	}
	
	/** 
	 * 
	 * frame
	 * 
	 * @param w
	 * @param h
	 * 
	 */
	public void frame( int w, int h ) {
		JFrame frame = new JFrame( "AppletBase" );
		this.createUI( frame, w, h );
		
		frame.addWindowListener( new WindowAdapter() {
			public void windowClosing( WindowEvent e ) {
				System.exit( 0 );
			}
		} );
		
		frame.setVisible( true );
	}

	/** 
	 * 
	 * actionPerformed
	 * 
	 * @param e
	 * 
	 */
	public void actionPerformed( ActionEvent e ) {
		printRates();
		System.exit( 0 );
	}

	////////////////////////////////////////////////////////////

	/** 
	 * 
	 * printRates
	 * 
	 */
	public float printRates() {
		long now = System.currentTimeMillis();
		long timeDiff = now - startTime;
		float secs = ( timeDiff ) / 1000.0f;
		float fps = fcount / secs;
		System.out.println( fcount + "/" + secs + "=" + fps + " fps" );
		if ( secs > 10 ) {
			startTime = now;
			fcount = 0;
		}
		return fps;
	}

	////////////////////////////////////////////////////////////
	// KeyListener

	/** 
	 * 
	 * keyReleased
	 * 
	 * @param e
	 * 
	 */
	public void keyReleased( KeyEvent e ) {
	}
	
	/** 
	 * 
	 * keyTyped
	 * 
	 * @param e
	 * 
	 */
	public void keyTyped( KeyEvent e ) {
	}
	
	/** 
	 * 
	 * keyPressed
	 * 
	 * @param e
	 * 
	 */
	public void keyPressed( KeyEvent e ) {
		switch( e.getKeyCode() ) {
			case KeyEvent.VK_SPACE: fx.statiq(); break;
			case KeyEvent.VK_S: printRates(); break;
			case KeyEvent.VK_P:	paused = !paused; break;
			case KeyEvent.VK_Q: System.exit( 0 ); break;
			case KeyEvent.VK_R:
				fcount = 0;
				startTime = System.currentTimeMillis();
				break;
			default:
				//System.out.println( "" + " e = " + e );
		}
	}

	////////////////////////////////////////////////////////////
	// MouseListener

	/** 
	 * 
	 * mousePressed
	 * 
	 * @param e
	 * 
	 */
	public void mousePressed( MouseEvent e ) {
		printRates();
		paused = true;
		mx = e.getX();
		my = e.getY();
		requestFocus();
	}

	/** 
	 * 
	 * mouseReleased
	 * 
	 * @param e
	 * 
	 */
	public void mouseReleased( MouseEvent e ) {
		requestFocus();
	}

	/** 
	 * 
	 * mouseClicked
	 * 
	 * @param e
	 * 
	 */
	public void mouseClicked( MouseEvent e ) {
	}
	
	/** 
	 * 
	 * mouseEntered
	 * 
	 * @param e
	 * 
	 */
	public void mouseEntered( MouseEvent e ) {
		requestFocus();
	}
	
	/** 
	 * 
	 * mouseExited
	 * 
	 * @param e
	 * 
	 */
	public void mouseExited( MouseEvent e ) {
	}
    
	////////////////////////////////////////////////////////////
	// MouseMotionListener
	
	/** 
	 * 
	 * mouseDragged
	 * 
	 * @param e
	 * 
	 */
	public void mouseDragged( MouseEvent e ) {
		requestFocus();
		int xd = e.getX() - mx;
	  	int yd = e.getY() - my;

		float xf = xd / ( float ) ( gl.getRenderer().getWidth() );
		float yf = yd / ( float ) ( gl.getRenderer().getHeight() );

		float f = 44.0f / 7.0f;
		rotation.setY( xf * f );
		rotation.setX( yf * f );
	}
	
	/** 
	 * 
	 * mouseMoved
	 * 
	 * @param e
	 * 
	 */
	public void mouseMoved( MouseEvent e ) {
	}

	/** 
	 * 
	 * getGl
	 * 
	 * @return a LiboGrafInterface
	 * 
	 */
	public LiboGrafInterface getGl() {
		if ( null == gl ) {
			gl = LiboGraf.createLiboGrafInterface( this );
			if ( null != gl ) {
				gl.init( this );
			}
		}
		return gl;
	}

	/** 
	 * 
	 * switchRenderer
	 * 
	 * @param rname
	 * 
	 */
	public void switchRenderer( String rname ) {
		this.rname = rname;
	}

	/** 
	 * 
	 * testHarness
	 * 
	 * @return a float
	 * 
	 */
	public float testHarness() {
		restart();

		// juice the goose
		do { 
			drawFrame();
		} while ( ( System.currentTimeMillis() - startTime ) / 1000.0 < 10 );

		// kick it!
		restart();
		while ( fcount < 2600 ) {
			drawFrame();
		}
		
		// fps it
		long now = System.currentTimeMillis();
		long timeDiff = now - startTime;
		float secs = ( timeDiff ) / 1000.0f;
		return fcount / ( ( timeDiff ) / 1000.0f );
	}

	/** 
	 * 
	 * setPerformanceTest
	 * 
	 * @param newValue
	 * 
	 */
	public void setPerformanceTest( boolean newValue ) {
		performanceTest = newValue;
	}

	//////////////

	private final void badJoke() {
		
		///gl = LiboGraf.createLiboGrafInterface( this );
		getGl();
		
		int[] sk = { 0x0000FF00 };
		skin = new ImageSkin( 1, 1, sk );
		
		fx = new BufferFx( gl.getRenderer() );

		gl.getRenderer().addDrawer( this );

		initImpl( w, h );
	}

	private void init( int w, int h ) {
		this.w = w;
		this.h = h;
		
		setSize( new Dimension( w, h ) );

		addKeyListener( this );
		addMouseListener( this );
		addMouseMotionListener( this );
	}

	private void createUI( JFrame frame, int w, int h ) {
		Container main = frame.getContentPane();

		JMenuBar menuBar = new JMenuBar();
		frame.setJMenuBar( menuBar );
		
		JMenu menu = new JMenu( "File" );
		menu.setMnemonic( KeyEvent.VK_F );
		menuBar.add( menu );

		JMenuItem menuItem = new JMenuItem( "Quit", KeyEvent.VK_Q );
		menu.add( menuItem );
		menuItem.addActionListener( this ); 
		
		main.setLayout( new BorderLayout() );

		init( w, h );
		main.add( this, BorderLayout.CENTER );
		this.start();

		frame.addKeyListener( this );

		main.add( this );
		frame.setSize( w, h );	
	}

	/** 
	 * 
	 * the5k
	 * 
	 */
	private final void the5k() {
		
		long timeDiff = System.currentTimeMillis() - startTime;
		float secs = ( timeDiff ) / 1000.0f;

		if ( secs < 30 ) {
			whenPerf *= 2;
		} else {

			String aname = getClass().getName();
			String rname = gl.getRenderer().getClass().getName();

			aname = aname.substring( 1 + aname.lastIndexOf( "." ) );
			rname = rname.substring( 1 + rname.lastIndexOf( "." ) );
			
			System.out.println( 
				"Rate\t" +
				rname + "@" + aname +
				"\t" + 
				fcount + "/" + secs + 
				"=" + 
				fcount / secs 
			);

			if ( performanceTest ) {
				keepRunning = false;
			}
		}
	}

	/** 
	 * 
	 * restart
	 * 
	 */
	public void restart() {
		keepRunning = true;
		startTime = System.currentTimeMillis();
		fcount = 0;
	}
		
	/** 
	 * 
	 * frame
	 * 
	 * @return a protected
	 * 
	 */
	protected final void drawFrame() {
		thread.setPriority( Thread.MAX_PRIORITY );
		repaint();
		thread.setPriority( Thread.MIN_PRIORITY );
		thread.yield();
	}
	
	////////////////////////////////////////////////////////////

	private void setShade( int shade_mode ) {
		String shadeType[] = { "NONE", "NORM", "DEPTH", "PHONG" };
		shade_mode %= 4;
		switch( shade_mode ) {
			case 0: gl.getRenderer().setShadingMethod( M3_Constants.NONE_SHADE );  break;
			case 1: gl.getRenderer().setShadingMethod( M3_Constants.NORM_SHADE );  break;
			case 2: gl.getRenderer().setShadingMethod( M3_Constants.DEPTH_SHADE ); break;
			case 3: gl.getRenderer().setShadingMethod( M3_Constants.PHONG_SHADE ); break;
		}
		System.out.println( "shade_mode = " + shade_mode + " : " + shadeType[ shade_mode ] );
	}

	////////////////////////////////////////////////////////////

	protected boolean paused = false;
	
	protected int mx, my;

	private int whenPerf = 5000;
	protected int fcount = 0;
	protected Thread thread = null;
	protected long startTime = System.currentTimeMillis();

	protected BufferFx fx;

	protected LiboGrafInterface gl = null;
	protected Pt3 rotation = new Pt3();

	protected ImageSkin skin = null;

	protected int shade_mode = 1;
	protected int w = 0, h = 0;

	private String rname = null;

	private boolean performanceTest = false;
	private boolean keepRunning = true;
};

/**
 *
 * $Log: AppletBase.java,v $
 * Revision 1.15  2005/03/29 02:38:33  brian
 * trying to round out perf testing stuff
 *
 * Revision 1.14  2005/03/26 23:42:41  brian
 * fix links
 *
 * Revision 1.13  2005/03/26 03:38:11  brian
 * don't auto unpause onMouseUp
 *
 * Revision 1.12  2005/03/21 05:56:22  brian
 * reset counter after 10sec if polled...
 *
 * Revision 1.11  2005/03/21 05:52:12  brian
 * add enuff stuff to be able to calc pps (polygons per second)
 *
 * Revision 1.10  2005/03/21 00:42:11  brian
 * reorg, comment public methods, reset fps after print...
 *
 * Revision 1.9  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.8  2005/03/11 23:35:31  brian
 * major refactoring to add in com.insanityengine.ghia.libograf.State bitz
 *
 * Revision 1.7  2004/09/16 11:07:45  brian
 * don't clear depth buffer by default each frame and allow size to be passed into frame method
 *
 * Revision 1.6  2004/09/11 21:27:10  brian
 * rework perf test
 *
 * Revision 1.5  2004/09/11 20:08:46  brian
 * added timing testing infrastructure...
 *
 * Revision 1.4  2004/09/11 19:32:29  brian
 * effects of adding LiboGrafInterface
 *
 * Revision 1.3  2004/09/11 14:37:21  brian
 * added RendererConsumer and stuff
 *
 * Revision 1.2  2004/09/05 03:41:31  brian
 * refactored to have the render method of the renderers invoke the drawingIfz
 *
 * Revision 1.1  2004/09/02 13:17:16  brian
 * the big reorg
 *
 * Revision 1.7  2004/09/01 01:10:42  brian
 * fix class level javadoc placement
 *
 * Revision 1.6  2004/09/01 00:11:06  brian
 * author, log and header stuff
 *
 *
 */
