package com.insanityengine.ghia.libograf;

import com.insanityengine.ghia.m3.Pt3;

/**
 *
 * <P>
 * This interface provides an implementation-agnostice mechanism to
 * set, get, push and pop state information.
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/libograf/State.java,v 1.4 2005/03/19 17:50:02 brian Exp $
 *
 */
public interface State {

	/** 
	 * 
	 * identity
	 * 
	 * @return a State
	 * 
	 */
	public State identity();
	
	/** 
	 * 
	 * rotate
	 *
	 * @param angle
	 * 
	 * @return a State
	 * 
	 */
	public State rotate( Pt3 angle );
	
	/** 
	 * 
	 * translate
	 * 
	 * @param displacement
	 * 
	 * @return a State
	 * 
	 */
	public State translate( Pt3 displacement );
	
	/** 
	 * 
	 * scale
	 * 
	 * @param ratio
	 * 
	 * @return a State
	 * 
	 */
	public State scale( Pt3 ratio );
	
	/** 
	 * 
	 * multiply: this = this * state
	 * 
	 * @param state
	 * 
	 * @return this State
	 * 
	 */
	public State multiply( State state );

	/** 
	 * 
	 * set
	 * 
	 * @param state
	 * 
	 * @return this State
	 * 
	 */
	public State set( State state );

	/** 
	 * 
	 * multiply
	 * 
	 * @param point
	 * @param destination
	 * 
	 * @return a Pt3
	 * 
	 */
	public Pt3 multiply( Pt3 point, Pt3 destination );
	
};

/**
 *
 * $Log: State.java,v $
 * Revision 1.4  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.3  2005/03/12 04:36:44  brian
 * fix javadoc
 *
 * Revision 1.2  2005/03/11 23:35:31  brian
 * major refactoring to add in com.insanityengine.ghia.libograf.State bitz
 *
 * Revision 1.1  2005/03/10 13:31:19  brian
 * introduce com.insanityengine.ghia/libograf/State to pave the way for quaternions based LiboGrafInterface implementation
 *
 *
 */
