package com.insanityengine.ghia.libograf;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.applet.*;

import com.insanityengine.ghia.m3.*;

/**
 * 
 * <P>
 * Typical zbuffer crap
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/libograf/ZeeBuffer.java,v 1.4 2005/03/19 17:50:02 brian Exp $
 *
 */

public class ZeeBuffer { 

	/**
	 *
	 * Constructor
	 *
	 */
	public ZeeBuffer() {}

	/**
	 *
	 * Constructor
	 *
	 * @param width of the buffer
	 * @param height of the buffer
	 *
	 */
	public ZeeBuffer( int width, int height ) {
		init( width, height );
	}

	/*
	 *
	 * Initialize this ZeeBuffer
	 *
	 * @param width of the buffer
	 * @param height of the buffer
	 *
	 */
	public final void init( int width, int height ) {
		this.w = width; 
		this.h = height;
		
		max = w * h;
		zbuffer = new float[ max ];
	}

	/**
	 *
	 * Get the current value for "far"
	 *
	 * @return the current value for "far"
	 *
	 */
	public final float getFar() { 
		return zFar; 
	}
  		  
	/**
	 *
	 * Set the value for "far"
	 *
	 * @param far value to use
	 *
	 */
	public final void setFar( float far ) {
		this.zFar = far;
	}

	/**
	 *
	 * Determines the width of the buffer. 
	 *
	 * @return the width of this buffer
	 *
	 */
	public final int getWidth() {
		return w;
	}

	/**
	 *
	 * Determines the height of the buffer. 
	 *
	 * @return the height of this buffer
	 *
	 */
	public final int getHeight() {
		return h;
	}

	/**
	 *
	 * Set and return true if this value is closer than the 
	 * point currently registered at (x,y,z)
	 *
	 * @param x coordinate
	 * @param y coordinate
	 * @param z coordinate
	 *
	 * @return true if closer, false if not
	 *
	 */
	public final boolean set( float x, float y, float z ) {
		return set( ( int ) ( x + y * w ), z );
	}

	/**
	 *
	 * Get the depth at screen coordinates
	 *
	 * @param x coordinate
	 * @param y coordinate
	 *
	 * @return the depth
	 *
	 */
	public final float get( float x, float y ) {
		return get( ( int ) ( x + y * w ) );
	}

	/**
	 *
	 * Set and return true if this value is closer than the 
	 * point currently registered at index
	 *
	 * @param index to check
	 * @param z coordinate
	 *
	 * @return true if closer, false if not
	 *
	 */
	public final boolean set( int index, float z ) {
		if ( z > zbuffer[ index ] ) return false;
		zbuffer[ index ] = z;
		return true;
	}
	
	/**
	 *
	 * Get the depth at screen coordinates
	 *
	 * @param index to check
	 *
	 * @return the depth
	 *
	 */
	public final float get( int index ) {
		return zbuffer[ index ];
	}

	/**
	 *
	 * Clear (reset to zfar) all the cells in the buffer
	 *
	 */
	public final void clear() {
		int cleared = 1;
		zbuffer[ 0 ] = zFar;
		for ( cleared = 1 ; cleared < max / 2 ; cleared *= 2 ) {
			System.arraycopy( zbuffer, 0, zbuffer, cleared, cleared );
		}
		System.arraycopy( zbuffer, 0, zbuffer, cleared, max - cleared );
	}

	////////////////////////////////////////////////////////////////////

	private int w = 0;
	private int h = 0;
	private int max = 0;
	
	private float zbuffer[] = null;
	
	private float zFar = M3_Constants.bigNumber;
	
};

/**
 *
 * $Log: ZeeBuffer.java,v $
 * Revision 1.4  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.3  2005/03/07 13:36:38  brian
 * invert the buffer to match other changes
 *
 * Revision 1.2  2005/02/17 03:31:13  brian
 * good stuff???
 *
 * Revision 1.1  2004/09/02 13:17:16  brian
 * the big reorg
 *
 * Revision 1.4  2004/09/01 01:10:42  brian
 * fix class level javadoc placement
 *
 * Revision 1.3  2004/09/01 00:11:06  brian
 * author, log and header stuff
 *
 *
 */
