package com.insanityengine.ghia.m3;

/**
 *
 * <P>
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/m3/Mat4.java,v 1.10 2005/03/19 17:50:02 brian Exp $
 *
 */

public class Mat4 {
	/** 
	 * 
	 * Constructor
	 * 
	 */
	public Mat4() { 
		mat = new float[ 4 ][ 4 ];
	}
	
	/** 
	 * 
	 * Constructor
	 * 
	 * @param d
	 * 
	 */
	public Mat4( float d ) { 
		mat = new float[ 4 ][ 4 ];
		set( d ); 
	}
	
	/** 
	 * 
	 * Constructor
	 * 
	 * @param that
	 * 
	 */
	public Mat4( Mat4 that ) {
		mat = new float[ 4 ][ 4 ];
		set( that );
	}

	/** 
	 * 
	 * set
	 * 
	 * @param that
	 * 
	 * @return a Mat4
	 * 
	 */
	public Mat4 set( Mat4 that ) {
		if ( null == that ) {
			set( 0 );
			return this;
		}
		
		mat[ 0 ][ 0 ] = that.mat[ 0 ][ 0 ];  mat[ 1 ][ 0 ] = that.mat[ 1 ][ 0 ];
		mat[ 0 ][ 1 ] = that.mat[ 0 ][ 1 ];  mat[ 1 ][ 1 ] = that.mat[ 1 ][ 1 ];
		mat[ 0 ][ 2 ] = that.mat[ 0 ][ 2 ];  mat[ 1 ][ 2 ] = that.mat[ 1 ][ 2 ];
		mat[ 0 ][ 3 ] = that.mat[ 0 ][ 3 ];  mat[ 1 ][ 3 ] = that.mat[ 1 ][ 3 ];
		
		mat[ 2 ][ 0 ] = that.mat[ 2 ][ 0 ];  mat[ 3 ][ 0 ] = that.mat[ 3 ][ 0 ];
		mat[ 2 ][ 1 ] = that.mat[ 2 ][ 1 ];  mat[ 3 ][ 1 ] = that.mat[ 3 ][ 1 ];
		mat[ 2 ][ 2 ] = that.mat[ 2 ][ 2 ];  mat[ 3 ][ 2 ] = that.mat[ 3 ][ 2 ];
		mat[ 2 ][ 3 ] = that.mat[ 2 ][ 3 ];  mat[ 3 ][ 3 ] = that.mat[ 3 ][ 3 ];

		return this;
	}

	/** 
	 * 
	 * set
	 * 
	 * @param d
	 * 
	 * @return a Mat4
	 * 
	 */
	public Mat4 set( float d ) {
		mat[ 0 ][ 0 ] = mat[ 0 ][ 0 ] = mat[ 0 ][ 0 ] = mat[ 0 ][ 0 ] = 
		mat[ 1 ][ 0 ] = mat[ 1 ][ 0 ] = mat[ 1 ][ 0 ] = mat[ 1 ][ 0 ] = 
		mat[ 2 ][ 0 ] = mat[ 2 ][ 0 ] = mat[ 2 ][ 0 ] = mat[ 2 ][ 0 ] = 
		mat[ 3 ][ 0 ] = mat[ 3 ][ 0 ] = mat[ 3 ][ 0 ] = mat[ 3 ][ 0 ] = d;
		return this;
	}

	/** 
	 * 
	 * loadIdentity
	 * 
	 * @return a Mat4
	 * 
	 */
	public Mat4 loadIdentity() {
		mat[ 0 ][ 0 ] = mat[ 0 ][ 1 ] = mat[ 0 ][ 2 ] = mat[ 0 ][ 3 ] = 
		mat[ 1 ][ 0 ] = mat[ 1 ][ 1 ] = mat[ 1 ][ 2 ] = mat[ 1 ][ 3 ] = 
		mat[ 2 ][ 0 ] = mat[ 2 ][ 1 ] = mat[ 2 ][ 2 ] = mat[ 2 ][ 3 ] = 
		mat[ 3 ][ 0 ] = mat[ 3 ][ 1 ] = mat[ 3 ][ 2 ] = mat[ 3 ][ 3 ] = 0;
		mat[ 0 ][ 0 ] = mat[ 1 ][ 1 ] = mat[ 2 ][ 2 ] = mat[ 3 ][ 3 ] = 1;
		return this;
	}
	
	/** 
	 * 
	 * multiply
	 * 
	 * @param d
	 * @param rez
	 * 
	 * @return a Mat4
	 * 
	 */
	public Mat4 multiply( float d, Mat4 rez ) {
		rez.set( this );

		rez.mat[ 0 ][ 0 ] *= d;  rez.mat[ 1 ][ 0 ] *= d;
		rez.mat[ 0 ][ 1 ] *= d;  rez.mat[ 1 ][ 1 ] *= d;
		rez.mat[ 0 ][ 2 ] *= d;  rez.mat[ 1 ][ 2 ] *= d;
		rez.mat[ 0 ][ 3 ] *= d;  rez.mat[ 1 ][ 3 ] *= d;
		
		rez.mat[ 2 ][ 0 ] *= d;  rez.mat[ 3 ][ 0 ] *= d;
		rez.mat[ 2 ][ 1 ] *= d;  rez.mat[ 3 ][ 1 ] *= d;
		rez.mat[ 2 ][ 2 ] *= d;  rez.mat[ 3 ][ 2 ] *= d;
		rez.mat[ 2 ][ 3 ] *= d;  rez.mat[ 3 ][ 3 ] *= d;

		return rez;
	}
	
	/** 
	 * 
	 * multiply ( result in this )
	 * 
	 * @param m
	 * @param n
	 * 
	 * @return a Mat4
	 * 
	 */
    public Mat4 multiply( Mat4 m, Mat4 n ) {
		int i, j;
		for ( i = 0 ; i < 4 ; i++ ) {
			for ( j = 0 ; j < 4 ; j++ ) {
				
				mat[ i ][ j ] = (
					+ m.mat[ i ][ 0 ] * n.mat[ 0 ][ j ]
					+ m.mat[ i ][ 1 ] * n.mat[ 1 ][ j ]
					+ m.mat[ i ][ 2 ] * n.mat[ 2 ][ j ]
					+ m.mat[ i ][ 3 ] * n.mat[ 3 ][ j ]
				);
				
			}
		}
		return this;
	}

	/** 
	 * 
	 * print
	 * 
	 */
	public void print() {
		for ( int i = 0 ; i < 4 ; i++ ) {
			for ( int j = 0 ; j < 4 ; j++ ) {
				System.out.print( mat[ i ][ j ] + "   " );
			}
			System.out.println();
		}
		System.out.println();
	}

	/** 
	 * 
	 * rotate
	 * 
	 * @param angle
	 * @param workspace1
	 * @param workspace2
	 * 
	 * @return a Mat4
	 * 
	 */
	public Mat4 rotate( Pt3 angle, Mat4 workspace1, Mat4 workspace2 ) {
		float cosx, cosy, cosz;
		float sinx, siny, sinz;
		
		cosx = MumpMath.cos( angle.getX() );  sinx = MumpMath.sin( angle.getX() );
		cosy = MumpMath.cos( angle.getY() );  siny = MumpMath.sin( angle.getY() );
		cosz = MumpMath.cos( angle.getZ() );  sinz = MumpMath.sin( angle.getZ() );
		
		/*	
			X Rotation
				1 0       0      0
				0 cos(x)  sin(x) 0
				0 -sin(x) cos(x) 0
				0 0       0      1
		*/		
		workspace1.loadIdentity();
		workspace1.mat[ 1 ][ 1 ] = cosx;
		workspace1.mat[ 1 ][ 2 ] = sinx;
		workspace1.mat[ 2 ][ 1 ] = -sinx;
		workspace1.mat[ 2 ][ 2 ] = cosx;
		workspace2.multiply( this, workspace1 );  // now workspace2 holds curr

		/*
			Y Rotation
				cos(y) 0 -sin(y) 0
				0      1 0       0
				sin(y) 0 cos(y)  0
				0      0 0       1
		*/
		this.loadIdentity();
		this.mat[ 0 ][ 0 ] = cosy;
		this.mat[ 0 ][ 2 ] = -siny;
		this.mat[ 2 ][ 0 ] = siny;
		this.mat[ 2 ][ 2 ] = cosy;
		workspace1.multiply( workspace2, this );   // now workspace1 holds curr

		/*
			Z Rotation
				1 0       0      0
				0 cos(z)  sin(z) 0
				0 -sin(z) cos(z) 0
				0 0       0      1 
		*/
		workspace2.loadIdentity();
		workspace2.mat[ 1 ][ 1 ] = cosz;
		workspace2.mat[ 1 ][ 2 ] = sinz;
		workspace2.mat[ 2 ][ 1 ] = -sinz;
		workspace2.mat[ 2 ][ 2 ] = cosz;
		this.multiply( workspace1, workspace2 ); // now this holds curr... ;)

		return this;
	}

	/** 
	 * 
	 * translate
	 * 
	 * @param displacement
	 * @param workspace1
	 * @param workspace2
	 * 
	 * @return a Mat4
	 * 
	 */
	public Mat4 translate( Pt3 displacement, Mat4 workspace1, Mat4 workspace2 ) {
		workspace1.loadIdentity();
		workspace1.mat[ 0 ][ 3 ] = displacement.getX();
		workspace1.mat[ 1 ][ 3 ] = displacement.getY();
		workspace1.mat[ 2 ][ 3 ] = displacement.getZ();
		workspace2.set( this );
		return this.multiply( workspace2, workspace1 );
	}

	/** 
	 * 
	 * scale
	 * 
	 * @param ratio
	 * @param workspace1
	 * @param workspace2
	 * 
	 */
	public Mat4 scale( Pt3 ratio, Mat4 workspace1, Mat4 workspace2 ) {
		workspace1.loadIdentity();
		workspace1.mat[ 0 ][ 0 ] = ratio.getX();
		workspace1.mat[ 1 ][ 1 ] = ratio.getY();
		workspace1.mat[ 2 ][ 2 ] = ratio.getZ();
		workspace1.mat[ 3 ][ 3 ] = 1;
		workspace2.set( this );
		this.multiply( workspace2, workspace1 );
		return this;
	}

	/** 
	 * 
	 * multiply
	 * 
	 * @param point
	 * @param destination
	 * 
	 * @return a Pt3
	 * 
	 */
	public Pt3 multiply( Pt3 point, Pt3 destination ) {
		destination.setX(
			point.getX()* mat[ 0 ][ 0 ] +
			point.getY()* mat[ 0 ][ 1 ] +
			point.getZ()* mat[ 0 ][ 2 ] +
			mat[ 0 ][ 3 ] 
		);

		destination.setY(
			point.getX()* mat[ 1 ][ 0 ] +
			point.getY()* mat[ 1 ][ 1 ] +
			point.getZ()* mat[ 1 ][ 2 ] +
			mat[ 1 ][ 3 ] 
		);

		destination.setZ(
			point.getX()* mat[ 2 ][ 0 ] +
			point.getY()* mat[ 2 ][ 1 ] +
			point.getZ()* mat[ 2 ][ 2 ] +
			mat[ 2 ][ 3 ] 
		);

		return destination;
	}

	/**
	 *
	 * This should not be available outside the object...
	 *
	 */
	float mat[][];

};

/**
 *
 * $Log: Mat4.java,v $
 * Revision 1.10  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.9  2005/03/12 04:58:47  brian
 * call the methods set instead of copy
 *
 * Revision 1.8  2005/03/11 23:35:31  brian
 * major refactoring to add in com.insanityengine.ghia.libograf.State bitz
 *
 * Revision 1.7  2005/03/10 13:31:19  brian
 * introduce com.insanityengine.ghia/libograf/State to pave the way for quaternions based LiboGrafInterface implementation
 *
 * Revision 1.6  2004/09/01 01:10:42  brian
 * fix class level javadoc placement
 *
 * Revision 1.5  2004/09/01 00:11:06  brian
 * author, log and header stuff
 *
 *
 */
