package com.insanityengine.ghia.m3;

import com.insanityengine.ghia.libograf.State;

/**
 *
 * <P>
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/m3/Matrix.java,v 1.3 2005/03/19 17:50:02 brian Exp $
 *
 */

public class Matrix extends Mat4 implements State {
	
	/** 
	 * 
	 * Constructor
	 * 
	 */
	public Matrix() { 
		super();
		ws1 = new Mat4();
		ws2 = new Mat4();
	}
	
	/** 
	 * 
	 * Constructor
	 * 
	 * @param d
	 * 
	 */
	public Matrix( float d ) { 
		super( d );
		ws1 = new Mat4();
		ws2 = new Mat4();
	}
	
	/** 
	 * 
	 * Constructor
	 * 
	 * @param that
	 * 
	 */
	public Matrix( Matrix that ) {
		super.set( that );
	}

	/**
	 *
	 * State interface:
	 *
	 */

	/** 
	 * 
	 * identity
	 * 
	 * @return a State
	 * 
	 */
	public State identity() {
		super.loadIdentity();
		return this;
	}
	
	/** 
	 * 
	 * rotate
	 *
	 * @param angle
	 * @param workspace1
	 * @param workspace2
	 * 
	 * @return a State
	 * 
	 */
	public State rotate( Pt3 angle ) {
		super.rotate( angle, ws1, ws2 );
		return this;
	}
	
	/** 
	 * 
	 * translate
	 * 
	 * @param displacement
	 * @param workspace1
	 * @param workspace2
	 * 
	 * @return a State
	 * 
	 */
	public State translate( Pt3 displacement ) {
		super.translate( displacement, ws1, ws2 );
		return this;
	}
	
	/** 
	 * 
	 * scale
	 * 
	 * @param ratio
	 * @param workspace1
	 * @param workspace2
	 * 
	 * @return a State
	 * 
	 */
	public State scale( Pt3 ratio ) {
		super.scale( ratio, ws1, ws2 );
		return this;
	}
	
	/** 
	 * 
	 * multiply
	 * 
	 * @param state
	 * 
	 * @return a State
	 * 
	 */
	public State multiply( State state ) {
		ws1.set( this );
		super.multiply( ws1.set( this ), ( Mat4 ) state );
		return this;
	}

	/** 
	 * 
	 * set
	 * 
	 * @param state
	 * 
	 * @return this State
	 * 
	 */
	public State set( State state ) {
		super.set( ( Mat4 ) state );
		return this;
	}

	/** 
	 * 
	 * multiply
	 * 
	 * @param point
	 * @param destination
	 * 
	 * @return a Pt3
	 * 
	 */
	//public Pt3 multiply( Pt3 point, Pt3 destination );

	/**
	 *
	 * This should not be available outside the object...
	 *
	 */
	private Mat4 ws1;
	private Mat4 ws2;

};

/**
 *
 * $Log: Matrix.java,v $
 * Revision 1.3  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.2  2005/03/12 04:58:47  brian
 * call the methods set instead of copy
 *
 * Revision 1.1  2005/03/11 23:36:37  brian
 * wraps Mat4 and adds workspace support
 *
 *
 */
