package com.insanityengine.ghia.m3;

import com.insanityengine.ghia.libograf.State;

/**
 *
 * <P>
 * </P>
 *
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/m3/Quaternion.java,v 1.4 2005/03/19 17:50:02 brian Exp $
 *
 */
public class Quaternion implements State {

	/** 
	 * 
	 * Constructor
	 * 
	 */
	public Quaternion() {
		quat = new Quat();
		ws1 = new Quat();
		ws2 = new Quat();
		ws3 = new Quat();
	}

	/** 
	 * 
	 * identity
	 * 
	 * @return a State
	 * 
	 */
	public State identity() {
		quat.identity();
		return this;
	}
	
	/** 
	 * 
	 * rotate
	 *
	 * @param angle
	 * 
	 * @return a State
	 * 
	 */
	public State rotate( Pt3 angle ) {
		quat.rotate( angle, ws1, ws2, ws3 );
		return this;
	}
	
	/** 
	 * 
	 * translate
	 * 
	 * @param displacement
	 * 
	 * @return a State
	 * 
	 */
	public State translate( Pt3 displacement ) {
		quat.translate( displacement );
		return this;
	}
	
	/** 
	 * 
	 * scale
	 * 
	 * @param ratio
	 * 
	 * @return a State
	 * 
	 */
	public State scale( Pt3 ratio ) {
		quat.scale( ratio );
		return this;
	}
	
	/** 
	 * 
	 * multiply: this = this * state
	 * 
	 * @param state
	 * 
	 * @return this State
	 * 
	 */
	public State multiply( State state ) {
		quat.multiply( 
			ws1.set( quat )
			, 
			( ( Quaternion ) state ).quat 
		);
		quat.normalize();
		return this;
	}

	/** 
	 * 
	 * set
	 * 
	 * @param state
	 * 
	 * @return this State
	 * 
	 */
	public State set( State state ) {
		quat.set( ( ( Quaternion ) state ).quat );
		return this;
	}

	/** 
	 * 
	 * multiply
	 * 
	 * @param point
	 * @param destination
	 * 
	 * @return a Pt3
	 * 
	 */
	public Pt3 multiply( Pt3 point, Pt3 destination ) {
		return quat.multiply( point, destination, ws1, ws2, ws3 );
	}
	
	///
	
	private Quat quat, ws1, ws2, ws3;
	
};

/**
 *
 * $Log: Quaternion.java,v $
 * Revision 1.4  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.3  2005/03/15 05:45:55  brian
 * closer...
 *
 * Revision 1.1  2005/03/12 04:51:28  brian
 * right or wrong, here they are...
 *
 *
 */
