package com.insanityengine.ghia.pixelops;

import com.insanityengine.ghia.pixels.PixelBufferReadInterface;

/**
 *
 * <P>
 * Various "post-production", usually 2d effects can be applied to (some) 
 * implementations of the PixelBufferReadInterface
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/pixelops/TextDitherer.java,v 1.3 2005/03/19 17:50:02 brian Exp $
 *
 */

public class TextDitherer {

	/**
  	 *	  
  	 * Silly text dithering...
  	 *	  
  	 */
	public final static void dither( PixelBufferReadInterface pbuffer ) {
		int rowz = 40;
		int colz = 78;
		int hdiv = pbuffer.getHeight() / rowz;
		int wdiv = pbuffer.getWidth() / colz;
		String px = "  `````-_..:::^^===++++rrrz)xiitLTullFJZjjSwkq5VVymXGUKAgHRB$QQQWW@@NN";
		int pdiv = 255 / px.length() + 1;


		int r, g, b;
		int i, j, y, x, idx;

		int ystart, ystop;
		int xstart, xstop;
			
		int c, color;

		// may be expensive in some (lame!) cases...
		int [] pixels = pbuffer.getPixels();

		for ( i = 0, ystart = 0, ystop = hdiv; i < rowz ; ++i, ystart = ystop, ystop += hdiv ) {

//			ystart = i * hdiv;
//			ystop = ystart + hdiv;

			for ( j = 0 ; j < colz ; ++j ) {

				xstart = j * wdiv;
				xstop = xstart + wdiv;

				color = 0;

				for ( y = ystart ; y < ystop ; ++y ) {

					for ( x = xstart ; x < xstop ; ++x ) {

						c = pixels[ x + y * pbuffer.getWidth() ];
						color += ( 
							+ ( c >> 16 & 0xFF )
							+ ( c >> 8 & 0xFF )
							+ ( c & 0xFF )
						) / 3;
					}
				}

				color /= ( wdiv * hdiv );
				//color = color * color / 255;
				//color = color * color / 255;
				//color = color * color / 255;
				//color = color * color / 255;

				idx = color / pdiv;
				System.out.print( px.charAt( idx ) );
			}
			System.out.println();
		}
	}
};

/**
 *
 * $Log: TextDitherer.java,v $
 * Revision 1.3  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.2  2004/09/16 10:58:47  brian
 * be marginally foxier...
 *
 * Revision 1.1  2004/09/13 00:53:39  brian
 * text dithering...
 *
 *
 */
