package com.insanityengine.ghia.pixels;

/**
 *
 * <P>
 * This PixelGetter converts negative coordinates to 
 * zero and x coordinates greater than or equal to 
 * width to width - 1 and y oordinates greater than or equal to 
 * height to height - 1. 
 * </P>
 *
 * <P>
 * The effect is to "clamp" the texture.
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/pixels/ClampPixelGetter.java,v 1.2 2005/03/19 17:50:02 brian Exp $
 *
 */

public class ClampPixelGetter extends PixelGetter {
	/**
	 *
	 * Constructor
	 *
	 */
	public ClampPixelGetter() { }

	/**
	 *
	 * Map the (x,y) into the pixels buffer and return
	 * the appropriate value via clamping
	 * 
	 * @param x coordinate
	 * @param y coordinate
	 * 
	 * @return appropriate pixel value for (x,y)
	 *
	 */
	public int getPixelAt( int x, int y ) {
		if ( x < 0 ) x = 0;
		if ( y < 0 ) y = 0;
		if ( x >= w ) x = w - 1;
		if ( y >= h ) y = h - 1;
		return super.getPixelAt( x, y );
	}
};

/**
 *
 * $Log: ClampPixelGetter.java,v $
 * Revision 1.2  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.1  2004/09/02 13:17:16  brian
 * the big reorg
 *
 * Revision 1.3  2004/09/01 01:10:42  brian
 * fix class level javadoc placement
 *
 * Revision 1.2  2004/09/01 00:11:06  brian
 * author, log and header stuff
 *
 *
 */
