package com.insanityengine.ghia.pixels;

import java.awt.*;
import java.awt.image.*;

import java.net.URL;

/**
 *
 * <P>
 * Facility to create ImageSkin's from filename, url, etc
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/pixels/Imago.java,v 1.2 2005/03/19 17:50:02 brian Exp $
 *
 */

public class Imago {
	
	/**
	 *
	 * Constructor
	 *
	 * @param component to use (can this be weaker?)
	 *
	 */
	public static final void setComponent( Component component ) {
		Imago.observer = Imago.component = component;
		tracker = new MediaTracker( component );
	}

	/**
	 *
	 * Skin an image given a filename 
	 *
	 * @param filename of the image
	 * @param relative toggle pwd or not
	 *
	 * @return an ImageSkin
	 *
	 */
	public static final ImageSkin skinImage( String filename, boolean relative ) {
        try {
            java.io.File file = new java.io.File( "." );
			return skinImage( 
				"file:" + file.getCanonicalPath() + file.separator +
				filename
			);
        } catch ( Exception e ) {
		}
		return null;
	}

	/**
	 *
	 * Skin an image given an href
	 *
	 * @param filename of the image
	 *
	 * @return an ImageSkin
	 *
	 */
	public static final ImageSkin skinImage( String href ) {
		ImageSkin skin = null;
		
		System.out.println( "Imago::skinImage " + href );

		try {
			Image image = Toolkit.getDefaultToolkit().getImage( new URL( href ) );
			
			tracker.addImage( image, 0 );
			try { 
				tracker.waitForID( 0 );
				skin = new ImageSkin( image, observer );
			} catch ( Exception e ) { 
				e.printStackTrace();
			}
			
		} catch ( Exception fe ) {
			fe.printStackTrace();
		}
		
		System.out.println( "Imago::skinImage: " + skin);
		
		return skin;
	}

	///
	
	private static Component component = null;
	private static ImageObserver observer = null;
	private static MediaTracker tracker = null;

};

/**
 *
 * $Log: Imago.java,v $
 * Revision 1.2  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.1  2004/09/02 13:17:16  brian
 * the big reorg
 *
 * Revision 1.5  2004/09/01 01:10:42  brian
 * fix class level javadoc placement
 *
 * Revision 1.4  2004/09/01 00:11:06  brian
 * author, log and header stuff
 *
 *
 */
