package com.insanityengine.ghia.pixels;

/**
 *
 * <P>
 * The read bits of the PixelBufferReadInterface are here to lower
 * the bar for implementations which only need very basic buffer 
 * functionality without all the cotton candy.
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/pixels/PixelBufferReadInterface.java,v 1.3 2005/03/19 17:50:02 brian Exp $
 *
 */

public interface PixelBufferReadInterface {

	/**
	 *
	 * Determines the width of the buffer. 
	 *
	 * @return the width of this buffer
	 *
	 */
	public int getWidth();

	/**
	 *
	 * Determines the height of the buffer. 
	 *
	 * @return the height of this buffer
	 *
	 */
	public int getHeight();

	/**
	 *
	 * Get the pixels
	 *
	 * @return the pixels
	 *
	 */
	public int[] getPixels();
	
	/**
	 *
	 * Get the clear color
	 *
	 * @return the clear color
	 *
	 */
	public int getClearColor();
	
};

/**
 *
 * $Log: PixelBufferReadInterface.java,v $
 * Revision 1.3  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.2  2004/09/02 15:43:46  brian
 * redefine PixelBufferReadInterface so BufferFx can use it as an interface rather than the RenderInterface
 *
 * Revision 1.1  2004/09/02 13:17:16  brian
 * the big reorg
 *
 * Revision 1.4  2004/09/01 01:10:42  brian
 * fix class level javadoc placement
 *
 * Revision 1.3  2004/09/01 00:11:06  brian
 * author, log and header stuff
 *
 *
 */
