package com.insanityengine.ghia.pixels;

/**
 *
 * <P>
 * Near trivial implementaton of the PixelGetterInterface interface
 * </P>
 *
 * @author BrianHammond
 *
 */

public class PixelGetter implements PixelGetterInterface { 

	/**
	 *
	 * Constructor
	 *
	 */
	public PixelGetter() { }

	/**
	 *
	 * Set the pixels and information for the getPixelAt method
	 *
	 * @param width of the image
	 * @param height of the image
	 * @param pixels of the image
	 *
	 */
	public final void setPixels( int width, int height, int pixels[] ) {
		this.w = width;
		this.h = height; 
		this.pixels = pixels;
	}

	/**
	 *
	 * Map the (x,y) into the pixels buffer and return
	 * the appropriate value
	 * 
	 * @param x coordinate
	 * @param y coordinate
	 * 
	 * @return appropriate pixel value for (x,y)
	 *
	 */
	public int getPixelAt( int x, int y ) {
		return pixels[ x + y * w ];
	}

	//

	protected int w = 1, h = 1;
	protected int [] pixels = nonPixels;

	protected final static int [] nonPixels = { 0xABADFEED };

};

/**
 *
 * $Log: PixelGetter.java,v $
 * Revision 1.2  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.1  2004/09/02 13:17:16  brian
 * the big reorg
 *
 * Revision 1.3  2004/09/01 01:10:42  brian
 * fix class level javadoc placement
 *
 * Revision 1.2  2004/09/01 00:11:06  brian
 * author, log and header stuff
 *
 *
 */
