package com.insanityengine.ghia.pixels;

/**
 *
 * <P>
 * This PixelGetter maps coordinates to indices by using the 
 * modulo of x % width and y % height.
 * </P>
 *
 * <P>
 * The effect is to "clamp" the texture.
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/pixels/WrapPixelGetter.java,v 1.2 2005/03/19 17:50:02 brian Exp $
 *
 */

public class WrapPixelGetter extends PixelGetter {
	/**
	 *
	 * Constructor
	 *
	 */
	public WrapPixelGetter() { }

	/**
	 *
	 * Map the (x,y) into the pixels buffer and return
	 * the appropriate value via wrapping
	 * 
	 * @param x coordinate
	 * @param y coordinate
	 * 
	 * @return appropriate pixel value for (x,y)
	 *
	 */
	public int getPixelAt( int x, int y ) {
		while ( x < 0 ) x += w;
		while ( y < 0 ) y += h;
		while ( x >= w ) x -= w;
		while ( y >= h ) y -= h;
		return super.getPixelAt( x, y );
	}
};

/**
 *
 * $Log: WrapPixelGetter.java,v $
 * Revision 1.2  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.1  2004/09/02 13:17:16  brian
 * the big reorg
 *
 * Revision 1.3  2004/09/01 01:10:42  brian
 * fix class level javadoc placement
 *
 * Revision 1.2  2004/09/01 00:11:06  brian
 * author, log and header stuff
 *
 *
 */
