package com.insanityengine.ghia.renderer.Edjo;

import com.insanityengine.ghia.m3.Pt3;

/** 
 * 
 * <P>
 * Edge class
 * </P>
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/renderer/Edjo/Edge.java,v 1.2 2005/03/26 05:06:38 brian Exp $
 * 
 * @author BrianHammond 
 * 
 */
public class Edge {
	
	/** 
	 * 
	 * Constructor
	 * 
	 */
	public Edge() {
	}

	/** 
	 * 
	 * set
	 * 
	 * @param min
	 * @param max
	 * 
	 */
	public void set( Pt3 min, Pt3 max ) {
		
		if ( min.getY() > max.getY() ) {
			set( max, min );
			return;
		}
		
		miny = ( int ) min.getY();
		maxy = ( int ) max.getY();
		if ( maxy == miny ) {
			dy = 1;
		} else {
			dy = maxy - miny;
		}

		minx = min.getX();
		minz = min.getZ();
		mins = min.getS();
		mint = min.getT();

		maxx = max.getX();

		dx = ( maxx - minx );
		dz = ( max.getZ() - minz );
		
		ds = ( max.getS() - mins );
		dt = ( max.getT() - mint );
	}

	/** 
	 * 
	 * hit
	 * 
	 * @param y
	 * @param hit
	 * 
	 * @return a boolean
	 * 
	 */
	public boolean hit( int y, Hit hit ) {
		if ( y < miny || y > maxy ) {
			return false;
		}

		if ( miny == maxy ) {
			hit.me( this, 1, minx, maxx );
		} else {
			float when = when( y );
			hit.me( this, when, xAt( when ) );
		}
		return true;
	}

	/** 
	 * 
	 * getMin
	 * 
	 * @return a float
	 * 
	 */
	public float getMin() {
		return miny;
	}

	/** 
	 * 
	 * getMax
	 * 
	 * @return a float
	 * 
	 */
	public float getMax() {
		return maxy;
	}

	/** 
	 * 
	 * when
	 * 
	 * @param y
	 * 
	 * @return a float
	 * 
	 */
	public float when( int y ) {
		return ( y - miny ) / dy;
	}

	/** 
	 * 
	 * xWhen
	 * 
	 * @param y
	 * 
	 * @return a float
	 * 
	 */
	public float xWhen( int y ) {
		return xAt( when( y ) );
	}

	/** 
	 * 
	 * tex
	 * 
	 * @param hit
	 * 
	 */
	public void tex( Hit hit ) {
		hit.set( 
			this,
			hit.when,
			mins + hit.when * ds,
			mint + hit.when * dt
		);
	}

	/** 
	 * 
	 * xAt
	 * 
	 * @param when
	 * 
	 * @return a float
	 * 
	 */
	public final float xAt( float when ) {
		return minx + when * dx;
	}
	
	/** 
	 * 
	 * zAt
	 * 
	 * @param when
	 * 
	 * @return a float
	 * 
	 */
	public final float zAt( float when ) {
		return minz + when * dz;
	}

	/** 
	 * 
	 * sAt
	 * 
	 * @param when
	 * 
	 * @return a float
	 * 
	 */
	public final float sAt( float when ) {
		return mins + when * ds;
	}

	/** 
	 * 
	 * tAt
	 * 
	 * @param when
	 * 
	 * @return a float
	 * 
	 */
	public final float tAt( float when ) {
		return mint + when * dt;
	}

	///////////
	
	private float dx, minx, maxx;
	private float dy, miny, maxy;

	private float dz, minz;

	private float ds, mins;
	private float dt, mint;
};

/**
 *
 * $Log: Edge.java,v $
 * Revision 1.2  2005/03/26 05:06:38  brian
 * refactor
 *
 *
 */
