package com.insanityengine.ghia.renderer;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.applet.*;

import com.insanityengine.ghia.m3.*;
import com.insanityengine.ghia.libograf.*;
import com.insanityengine.ghia.pixels.*;

/**
 *
 * <P>
 * This renderer uses the BufferBase for the bulk of it's functionality
 * but implements the tricky drawPolygon method
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/renderer/RendererBase.java,v 1.1 2005/03/25 03:07:54 brian Exp $
 *
 */
public abstract class RendererBase extends BufferBase implements RendererInterface {

	/**
	 *
	 * Render the next scene
	 * 
	 * @param context to use to render
	 *
	 */
	public void render( LiboGraf context ) {
		invokeDrawers( context );
		copyTo( context.getGraphics() );
	}

	//////////////////////////////////////////////////
	// DrawerRegistryInterface
	
	/**
	 *
	 * Some renderers are big babys about when it is ok to mess with their goodies.
	 * Hence this cheesy add/remove Drawer mess
	 *
	 * @param drawer to call per frame
	 *
	 */
	public void addDrawer( DrawingInterface drawer ) {
		registry.addDrawer( drawer );
	}

	/**
	 *
	 * Some renderers are big babys about when it is ok to mess with their goodies.
	 * Hence this cheesy add/remove Drawer mess
	 *
	 * @param drawer to call per frame
	 *
	 */
	public void removeDrawer( DrawingInterface drawer ) {
		registry.removeDrawer( drawer );
	}

	/**
	 *
	 * Invoke any registered DrawingInterfaces
	 *
	 */
	public void invokeDrawers( LiboGraf context ) {
		registry.invokeDrawers( context );
	}

	//////////////////////////////////

	private DrawerRegistry registry = new DrawerRegistry();

};

/**
 *
 * $Log: RendererBase.java,v $
 * Revision 1.1  2005/03/25 03:07:54  brian
 * centralize more cruft
 *
 *
 */
