package com.insanityengine.ghia.renderer;

//import java.util.Stack;

import java.awt.*;

import java.applet.Applet;
import java.awt.Component;
import java.awt.image.ImageObserver;

import com.insanityengine.ghia.m3.*;
import com.insanityengine.ghia.libograf.*;
import com.insanityengine.ghia.pixels.*;
import com.insanityengine.ghia.renderer.*;

/**
 *
 * <P>
 * Interface for RendererConsumer's 
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/renderer/RendererConsumerInterface.java,v 1.2 2005/03/19 17:50:02 brian Exp $
 *
 */

public interface RendererConsumerInterface {

	/**
	 *
	 * Initialize this RendererConsumer
	 *
	 * @param applet which provides context
	 *
	 */
	public void init( Applet applet );
	
	/**
	 *
	 * Initialize this RendererConsumer
	 *
	 * @param width of the display
	 * @param height of the display
	 * @param component to use
	 *
	 */
	public void init( int width, int height, java.awt.Component component );

	/**
	 *
	 * Create a renderer with a given size
	 *
	 * @param width of the renderer to create
	 * @param height of the renderer to create
	 *
	 * @return true on success, false on fail
	 *
	 */
	public boolean createRenderer( int width, int height );

	/**
	 * 
	 * Try to create a renderer given the name of the class 
	 * It will be initialized with the values passed into the init
	 * method of this LiboGraf instance
	 *
	 * @param nameOfRenderer to try to use
	 *
	 * @return true if succeds, else false
	 *
	 */
	public boolean createRenderer( String nameOfRenderer );

	/**
	 *
	 * Create a renderer of the default type using the values from 
	 * sent to init
	 *
	 * @return true if succeds, else false
	 *
	 */
	public boolean createRenderer();
	
	/**
	 *
	 * Get the renderer
	 *
	 * @return the renderer
	 *
	 */
	public RendererInterface getRenderer();

	/**
	 *
	 * Set the renderer
	 *
	 * @param renderer to use
	 *
	 */
	public void setRenderer( RendererInterface renderer );

	/**
	 *
	 * Render the scene
	 *
	 */
	public void render( LiboGraf gl );

	/**
	 *
	 * Set the graphics to use
	 * 
	 * @param graphics to use
	 *
	 */
	public void setGraphics( Graphics graphics );
	
	/**
	 *
	 * Get the graphics
	 *
	 */
	public Graphics getGraphics();
	
};

/**
 *
 * $Log: RendererConsumerInterface.java,v $
 * Revision 1.2  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.1  2004/09/11 14:44:59  brian
 * each class should have an interface and vice versa...
 *
 *
 */
