package com.insanityengine.ghia.util;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;

import javax.swing.*;

/**
 *
 * <P>
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/util/ComponentUtil.java,v 1.5 2005/03/19 17:50:02 brian Exp $
 *
 */

public class ComponentUtil {

	/**
	 * 
	 * 
	 * 
	 */
	public final static void main( String argv[] ) {
		if ( 0x00 == argv.length ) {
			final JFrame frame = new JFrame( "Tada" );
			JButton butt = new JButton( "Click here..." );
			butt.addActionListener( 
				new ActionListener() {
					public void actionPerformed( ActionEvent e ) {
						saveAsJpeg( frame, "tada.jpg" );
						System.exit( 0 );
					}
				}
			);
			frame.getContentPane().add( butt );
			frame.pack();
			frame.setVisible( true );
		} else {
		}
	}

	/**
	 *
	 * Save a component to a jpeg
	 *
	 * @param theImage to save 
	 * @param observer to use (total pain)
	 * @param filename to save to
	 *
	 * @return return success/fail
	 *
	 */
	final public static boolean saveAsJpeg( Image theImage, ImageObserver observer, String filename ) {
		boolean succeeded = false;
		BufferedImage image = (
			new BufferedImage(
				theImage.getWidth( observer ),
				theImage.getHeight( observer ),
				BufferedImage.TYPE_INT_RGB
			)
		);
		Graphics2D g2 = image.createGraphics();
		g2.drawImage( theImage, 0, 0, observer );
		return saveAsJpeg( image, filename );
	}

	/**
	 *
	 * Save a component to a jpeg
	 *
	 * Thanks to http://www.jguru.com/faq/view.jsp?EID=242020 for the refresher!
	 *
	 * @param component to save 
	 * @param filename to save to
	 *
	 * @return return success/fail
	 *
	 */
	final public static boolean saveAsJpeg( Component component, String filename ) {
		boolean succeeded = false;
		Dimension size = component.getSize();
		BufferedImage image = (
			new BufferedImage(
				size.width, 
				size.height,
				BufferedImage.TYPE_INT_RGB
			)
		);
		Graphics2D g2 = image.createGraphics();
		component.paint( g2 );
		return saveAsJpeg( image, filename );
	}

	/**
	 *
	 * Save a BufferedImage to a jpeg
	 *
	 * @param image to save 
	 * @param filename to save to
	 *
	 * @return return success/fail
	 *
	 */
	final public static boolean saveAsJpeg( BufferedImage image, String filename ) {
		boolean succeeded = false;
		try {
			java.io.OutputStream out = new java.io.FileOutputStream( filename );
			com.sun.image.codec.jpeg.JPEGImageEncoder encoder = (
				com.sun.image.codec.jpeg.JPEGCodec.createJPEGEncoder( out )
			);
			encoder.encode( image );
			out.close();
			succeeded = true;
		} catch ( Exception e ) {
			//System.out.println(e); 
		}
		return succeeded;
	}

	
	
};

/**
 *
 * $Log: ComponentUtil.java,v $
 * Revision 1.5  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.4  2005/02/17 03:31:13  brian
 * good stuff???
 *
 *
 */
