package com.insanityengine.ghia.util;

import java.lang.reflect.*;

/**
 *
 * <P>
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/util/DocReflect.java,v 1.6 2005/03/19 17:50:02 brian Exp $
 *
 */

public class DocReflect {

	/**
	 * 
	 * The main method rox!
	 * 
	 * @param argv the array of String
	 * 
	 */
	public final static void main( String argv[] ) {
		for ( int i = 0 ; i < argv.length ; ++i ) {
			DocReflect.reflectOn( argv[ i ] );
		}

	}

	public DocReflect() {}

	/**
	 * 
	 * The reflectOn method rox!
	 * 
	 * @param className the String
	 * 
	 */
	public final static void reflectOn( String className ) {
		Class theClass = forName( className );
		if ( null != theClass ) {
			publicMethods( theClass );
		} else {
			System.err.println( "No class for " + className );
		}
	}

	/**
	 * 
	 * The forName method rox!
	 * 
	 * @param className the String
	 * 
	 * @return the Class
	 * 
	 */
	public final static Class forName( String className ) {
		Class lass = null;
		try {
			lass = Class.forName( className );
		} catch ( Exception e ) {
		}
		return lass;
	}

	/**
	 * 
	 * The publicMethods method rox!
	 * 
	 * @param theClass the Class
	 * 
	 */
	public final static void publicMethods( Class theClass ) {
		
		Method [] methods = theClass.getMethods();
		if ( null != methods ) {

			String currentPackage = theClass.getName();
			currentPackage = currentPackage.substring( 0, currentPackage.lastIndexOf( '.' ) + 1 );

			for ( int i = 0 ; i < methods.length ; ++i ) {
				if ( theClass == methods[ i ].getDeclaringClass() ) {
					publicMethod( currentPackage, methods[ i ] );
				}
			}
		}
	}

	/**
	 * 
	 * The publicMethod method rox!
	 * 
	 * @param currentPackage the String
	 * @param method the java.lang.reflect.Method
	 * 
	 */
	public final static void publicMethod( String currentPackage, Method method ) {

		System.out.println( "\t/**" );
		System.out.println( commentPrefix );
		
		if ( null != method ) {
			System.out.println( commentPrefix + "The " + method.getName() + " method rox!" );
			parameters( currentPackage, method.getParameterTypes() );
			returnType( currentPackage, method.getReturnType() );
		}
		System.out.println( commentPrefix );
		System.out.println( "\t */" );
		System.out.println();
	}	

	/**
	 * 
	 * The parameters method rox!
	 * 
	 * @param currentPackage the String
	 * @param params the array of Class
	 * 
	 */
	public final static void parameters( String currentPackage, Class [] params ) {
		if ( null != params && 0 != params.length ) {
			System.out.println( commentPrefix );
			for ( int i = 0 ; i < params.length ; ++i ) {
				
				String type = params[ i ].getName();
				String array = "";

				if ( 0 == type.indexOf( "[L" ) ) {
					type = type.substring( 2, type.length() - 1 );
					array = "array of ";
				}

				type = removeFrom( "java.lang.", type );
				type = removeFrom( currentPackage, type );
					
				String name = "the" + type.substring( type.lastIndexOf( '.' ) + 1 );
				
				System.out.println( commentPrefix + "@param " + name + " the " + array + type ); 
			}
		}
	}

	/**
	 * 
	 * The returnType method rox!
	 * 
	 * @param currentPackage the String
	 * @param rtype the Class
	 * 
	 */
	public final static void returnType( String currentPackage, Class rtype ) {
		String type = rtype.getName();
		if ( !type.equals( "void" ) ) {

			System.out.println( commentPrefix );
		
			String array = "the ";
			
			if ( 0 == type.indexOf( "[L" ) ) {
				type = type.substring( 2, type.length() - 1 );
				array = "array of ";
			}

			type = removeFrom( "java.lang.", type );
			type = removeFrom( currentPackage, type );

			String name = "the" + type.substring( type.lastIndexOf( '.' ) + 1 );

			System.out.println( commentPrefix + "@return " + array + type ); 
		}
	}

	/**
	 * 
	 * The removeFrom method rox!
	 * 
	 * @param base the String
	 * @param str the String
	 * 
	 * @return the String
	 * 
	 */
	public final static String removeFrom( String base, String str ) {
		String s = str;
		if ( 0 == str.indexOf( base ) ) {
			s = str.substring( base.length() );
			if ( -1 != s.indexOf( '.' ) ) s = str;
		}
		return s;
	}

	// private 

	private final static String commentPrefix = "\t * ";
	
};

/**
 *
 * $Log: DocReflect.java,v $
 * Revision 1.6  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.5  2004/09/01 01:10:42  brian
 * fix class level javadoc placement
 *
 * Revision 1.4  2004/09/01 00:11:06  brian
 * author, log and header stuff
 *
 *
 */
