package com.insanityengine.ghia.util;

import java.io.File;
import java.util.Vector;
import java.util.Stack;

/**
 *
 * <P>
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/util/FileTree.java,v 1.7 2005/03/19 17:50:02 brian Exp $
 *
 */

public class FileTree {
	
	//

	/**
	 *
	 */
	public FileTree() {
		reset();
	}

	/**
	 *
	 */
	public FileTree( String start ) throws java.io.IOException {
		init( start );
	}
	
	public FileTree( File f ) throws java.io.IOException {
		init( f );
	}
	
	/**
	 *
	 */
	public FileTree( String start, FileTree parent ) throws java.io.IOException {
		init( start, parent );
	}

	/**
	 *
	 */
	public FileTree( File f, FileTree parent ) throws java.io.IOException {
		init( f, parent );
	}

	/**
	 *
	 */
	public void reset() {
		file = null;
		parent = null;
		kidz = null;
		isDir = false;
		length = kid_len = desc_len = kid_count = desc_count = 0;
	}

	/**
	 *
	 */
	public void init( String start ) throws java.io.IOException {
		init( new File( start ), null );
	}
	
	/**
	 *
	 */
	public void init( String start, FileTree p ) throws java.io.IOException {
		init( new File( start ), p );
	}

	/**
	 *
	 */
	public void init( File f ) throws java.io.IOException {
		init( f, null );
	}
	
	/**
	 *
	 */
	public void init( File f, FileTree p ) throws java.io.IOException {
		reset();

		file = f;
		parent = p;

		// collect some file info
		length = file.length();

		if ( !file.isDirectory() ) {
			return;	
		}

		isDir = true;

		File[] files = file.listFiles();
		if ( null == files ) { 
			return;
		}

        //length = kid_count = desc_count = 0;
		
		kid_count = files.length;
		kidz = new FileTree[ ( int ) kid_count ];
		for ( int i = 0 ; i < kid_count ; i++ ) {
			FileTree kid = kidz[ i ] = new FileTree( files[ i ], this );

			desc_count += 1 + kid.desc_count;
			desc_len   += kid.desc_len + kid.length;
			kid_len    += kid.kid_len  + kid.length;
		}
	}

	/**
	 *
	 * Get the number of descendants
	 *
	 * @return the number of descendants
	 *
	 */
	public long getDescendantCount() { return desc_count; }

	// private

	private File file = null;
	private FileTree parent = null;
	private FileTree kidz[] = null;

	private boolean isDir = false;
	private long length, kid_len, desc_len, kid_count, desc_count;

	
};

/**
 *
 * $Log: FileTree.java,v $
 * Revision 1.7  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.6  2004/09/01 01:10:42  brian
 * fix class level javadoc placement
 *
 * Revision 1.5  2004/09/01 00:11:06  brian
 * author, log and header stuff
 *
 *
 */
