package com.insanityengine.ghia.util;

import java.io.File;

import java.util.regex.Pattern;
import java.util.regex.Matcher;

/**
 *
 * <P>
 * </P>
 *
 * @author BrianHammond
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/util/NameFileFilter.java,v 1.6 2005/03/19 17:50:02 brian Exp $
 *
 */

public class NameFileFilter implements FileFilter {

	public NameFileFilter() {
		p = null;
	}

	public void init( String val ) {
		int next, curr = 0;

		String pal;

		// escape the .
		pal = "";
		curr = 0;
		while ( -1 != ( next = val.indexOf( ".", curr ) ) ) {
			pal += val.substring( curr, next ) + "\\.";
			curr = next + 1;
		}
		if ( curr < val.length() ) pal += val.substring( curr );

		val = pal;

		// expand * to .*
		pal = "";
		curr = 0;
		while ( -1 != ( next = val.indexOf( "*", curr ) ) ) {
			pal += val.substring( curr, next ) + ".*";
			curr = next + 1;
		}
		if ( curr < val.length() ) pal += val.substring( curr );

		p = Pattern.compile( pal );
	}

	public boolean accept( File f ) {
		return ( 
			p.matcher(
				f.toString().substring(
					f.toString().lastIndexOf( File.separator ) + 1
				)
			).matches()
		);
	}

	public String getName() {
		return "NameFileFilter";
	}

	//

	private Pattern p;
}

/**
 *
 * $Log: NameFileFilter.java,v $
 * Revision 1.6  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.5  2004/09/01 01:10:42  brian
 * fix class level javadoc placement
 *
 * Revision 1.4  2004/09/01 00:11:06  brian
 * author, log and header stuff
 *
 * Revision 1.3  2004/08/27 02:52:51  brian
 * brought the expr more in line with the unix cli and less with posix... is this a good thing or a bad thing? it strives towards the principle of least astonishment
 *
 */

