package com.insanityengine.ghia.util;

/**
 *
 * <P>
 * Convenient stdlib type stuff
 * </P>
 *
 * $Header: /usr/local/cvsroot/ghia/src/java/com/insanityengine/ghia/util/Stdlib.java,v 1.5 2005/03/19 17:50:02 brian Exp $
 *
 * @author BrianHammond
 *
 */

public class Stdlib {

	public final static Object NULL = null;
	public final static long RAND_MAX = 2147483647;

	/**
	 *  cheap version of System.out.println
	 *
	 *
	 */
	public static void sout( Object o ) { System.out.println( o ); }

	/**
	 *  inspired by the classic c function of the same name...
	 *  @return what you would expect
	 */
	public static long atol( String s ) {
		try { return Long.valueOf( s ).longValue(); } 
		catch ( Exception e ) { return 0; }
	}

	/**
	 *  inspired by the classic c function of the same name...
	 *  @return what you would expect
	 */
	public static int atoi( String s ) {
		try { return Integer.valueOf( s ).intValue(); } 
		catch ( Exception e ) { return 0; }
	}

	/**
	 *  inspired by the classic c function of the same name...
	 *  @return what you would expect if you expect a float
	 */
	public static float atof( String s ) {
		try { return Float.valueOf( s ).floatValue(); } 
		catch ( Exception e ) { return 0; }
	}
	
	/**
	 *  inspired by the classic c function of the same name...
	 *  @return what you would expect
	 */
	public static double atod( String s ) {
		try { return Double.valueOf( s ).doubleValue(); } 
		catch ( Exception e ) { return 0; }
	}

	/**
	 *  inspired by the classic c function of the same name...
	 *  @return what you would expect
	 */
	public static long rand() {
		return ( long ) ( Math.random() * RAND_MAX );
	}

	/**
	 *  inspired by the classic c function of the same name...
	 *  @return what you would expect
	 */
	public static int irand() {
		return ( int ) rand();
	}

	/**
	 * public static toString( String[] strz ) {
	 * @param x
	 * @return x
	 */
	public static String toString( String[] strz ) {
		StringBuffer sb = new StringBuffer();
		for ( int i = 0 ; i < strz.length ; i++ ) {
			if ( 0 != i ) sb.append( ", " );
			sb.append( "\"" ).append( strz[ i ] ).append( "\"" );
		}
		return sb.toString();
	}

};

/**
 * 
 * $Log: Stdlib.java,v $
 * Revision 1.5  2005/03/19 17:50:02  brian
 * repackaging
 *
 * Revision 1.4  2004/09/22 03:03:08  brian
 * added cheesy irand method
 *
 * Revision 1.3  2004/09/01 17:40:57  brian
 * atof returns float atod returns double, screwy, aint it?
 *
 * Revision 1.2  2004/09/01 14:10:12  brian
 * fixed typo in package name
 *
 * Revision 1.1  2004/09/01 14:06:32  brian
 * from moogl
 *
 *
 */
